// $Id$
//
// Copyright (C) 2006 

#ifndef HH_HTTPRequest_
#define HH_HTTPRequest_ 1

// Custom includes
#include <exception>
#include <string>
#include <map>
#include <boost/range/iterator_range.hpp>
#include "Socket/FileHandle.hh"

//#include "HTTPRequest.mpp"
///////////////////////////////hh.p////////////////////////////////////////

namespace g0dil {
namespace mediaserv {
    
    class HTTPRequest
    {
    public:
        ///////////////////////////////////////////////////////////////////////////
        // Types

        ///////////////////////////////////////////////////////////////////////////
        ///\name Structors and default members
        ///@{

	HTTPRequest();
        HTTPRequest(satcom::lib::FileHandle handle, std::string const & request);

        ///@}
        ///////////////////////////////////////////////////////////////////////////
        ///\name Accessors
        ///@{
	
	std::string const & host() const;
	std::string const & method() const;
	std::string const & url() const;
	std::string const & version() const;
	std::string const & operator[](std::string const & key) const;

        ///@}
        ///////////////////////////////////////////////////////////////////////////
        ///\name Mutators
        ///@{

	void parseRequest(satcom::lib::FileHandle handle, std::string const & request);

        ///@}

    protected:

    private:
	void parseRequestURL(boost::iterator_range<std::string::const_iterator> line);
	void parseRequestHeader(boost::iterator_range<std::string::const_iterator> line);

	typedef std::map<std::string,std::string> Headers;

	std::string host_;
	std::string method_;
	std::string url_;
	std::string version_;
	Headers headers_;
    };

    struct InvalidHTTPRequestException : public std::exception
    { char const * what() const throw() { return "invalid http request"; } };
    
}}

///////////////////////////////hh.e////////////////////////////////////////
#include "HTTPRequest.cci"
//#include "HTTPRequest.ct"
//#include "HTTPRequest.cti"
//#include "HTTPRequest.mpp"
#endif


// Local Variables:
// mode: c++
// End:
