// $Id$
//
// Copyright (C) 2006 

// Definition of non-inline non-template functions

// TODO: success logging
// TODO: limit max number of clients

#include "SimpleHTTPServer.hh"
//#include "SimpleHTTPServer.ih"

// Custom includes
#include "Utils/membind.hh"

//#include "SimpleHTTPServer.mpp"
#define prefix_
///////////////////////////////cc.p////////////////////////////////////////

g0dil::mediaserv::SimpleHTTPServer * g0dil::mediaserv::SimpleHTTPServer::instance_ = 0;

prefix_ g0dil::mediaserv::SimpleHTTPServer::SimpleHTTPServer(ServerHandle socket,
                                                             HTTPLogger & logger)
    : socket_(socket), logger_(logger)
{
    instance_ = this;
    satcom::lib::Scheduler::instance()
	.add(socket_, 
	     satcom::lib::membind(&SimpleHTTPServer::newConnection,this),
	     satcom::lib::Scheduler::EV_READ);
}

prefix_ g0dil::mediaserv::SimpleHTTPServer::~SimpleHTTPServer()
{
    instance_ = 0;
}

prefix_ void
g0dil::mediaserv::SimpleHTTPServer::newConnection(ServerHandle handle,
                                                  satcom::lib::Scheduler::EventId event)
{
    if (event != satcom::lib::Scheduler::EV_READ) {
	logger_.failedRequest("unexpected event on server socket .. shuting down ..");
	satcom::lib::Scheduler::instance().terminate();
	return;
    }
    try {
	ServerHandle::ClientSocketHandle client (socket_.accept());
	if (! client.valid()) {
	    logger_.failedRequest("accept() would block !?");
	    return;
	}
	connections_.insert(HTTPConnection::ptr(new HTTPConnection(client,*this,logger_)));
    }
    catch (std::exception & ex) {
	logger_.failedRequest(ex.what());
    }
}

prefix_ void g0dil::mediaserv::SimpleHTTPServer::done(HTTPConnection::ptr connection)
{
    connections_.erase(connection);
}

///////////////////////////////cc.e////////////////////////////////////////
#undef prefix_
//#include "SimpleHTTPServer.mpp"


// Local Variables:
// mode: c++
// End:
